with Ada.Text_IO;
package body Model_Viewer is

   procedure Add_Dependent (Model : in out Model_Type;
                            View  : in     View_Ptr) is
   begin
      Model.Num_Dependents := Model.Num_Dependents + 1;
      Model.Dependents (Model.Num_Dependents) := View;
   exception
      when CONSTRAINT_ERROR =>
         Ada.Text_IO.Put_Line (File => Ada.Text_IO.Standard_Error,
                               Item => "I already have too many dependents");
   end Add_Dependent;


   procedure Change (Model : in out Model_Type) is
   begin
      for Index in 1..Model.Num_Dependents loop
         Update (Model.Dependents(Index).all);
      end loop;
   end Change;

end Model_Viewer;
