import java.io.*;

public class CounterBoxView extends View
{
   public CounterBoxView (Model  whatIWatch,
                          String boxCharacter,
                          String fileName)
   {
      super(whatIWatch);

      myBoxCharacter = boxCharacter;

      try
      {
         myPrintStream   = new PrintStream( new FileOutputStream( fileName ) );
      }
      catch (IOException e)
      {
         System.out.println( e );
      }
   }

   public void update ()
   {
      drawLine( 20 );
      myPrintStream.print( myBoxCharacter );

      int i;
      for (i = 0; i < 8; i++)
          myPrintStream.print( " " );

      myPrintStream.println( getModel().value() );
      drawLine( 20 );
   }

   private String      myBoxCharacter;
   private PrintStream myPrintStream;

   private void drawLine( int numberOfCharacters )
   {
      int i;
      for (i = 0; i < numberOfCharacters; i++)
          myPrintStream.print( myBoxCharacter );
      myPrintStream.println();
   }
}
