with Ada.Text_IO;
use  Ada.Text_IO;
package body Reactor is

   procedure Add_Dependent (Model : in  Reactor_Ptr;
                            View  : in  Reactor_Ptr)is
   begin
      Model.all.Num_Dependents := Model.all.Num_Dependents + 1;
      Model.all.Dependents (Model.all.Num_Dependents) := View;
   exception
      when CONSTRAINT_ERROR =>
         Put_Line (File => Ada.Text_IO.Standard_Error,
                   Item => "I already have too many dependents");
   end Add_Dependent;


   procedure Change (Model : in Reactor_Ptr) is
   begin
      Put_Line (Model.all.Name.all & " is changing.");
      for Index in 1..Model.all.Num_Dependents loop
         Update (Sender => Model,
                 View   => Model.all.Dependents(Index));
      end loop;
   end Change;


   procedure Update (View   : in Reactor_Ptr;
                     Sender : in Reactor_Ptr) is
   begin
      Put_Line ("Uh-oh...  " & View.all.Name.all & " has to change because " &
                Sender.all.Name.all & " has changed.");
      Change (View);
   end Update;


end Reactor;
