(load "clos.cl")

(defclass reactor ()
   ((name               :accessor reactor-name
                        :initarg  :name
                        :initform "")
    (dependents         :accessor reactor-dependents
                        :initform '())
    (maximum-dependents :allocation :class
                        :accessor reactor-maximum
                        :initform 10)
   ))

(defmethod add-dependent ((receiver reactor) (watcher reactor))
   (if (< (length (reactor-dependents receiver)) (reactor-maximum receiver))
       (setf (reactor-dependents receiver)
             (append (reactor-dependents receiver) (list watcher)))
       (format t "I already have too many dependents!")
   ))

(defmethod change ((receiver reactor))
   (format t "~A is changing.~%" (reactor-name receiver))
   (mapcar #'(lambda (dependent)
                (update dependent receiver))
           (reactor-dependents receiver))
   )

(defmethod update ((receiver reactor) (sender reactor))
   (format t "Uh-oh...  ~A has to change because ~A has changed.~%"
          (reactor-name receiver)
          (reactor-name sender  ))
   (change receiver)
   )
